$!+
$! CVT__HTML.COM
$! convert .HTML files to .RNO files.
$! Uses: [.VMS]PYTHON_arch.EXE + [.VMS.TOOLS]HTML2RNO.PY
$! procedure is called from CVT_DOC.COM
$! no special error checking (e.g. empty .HTML files) !
$!
$! 06-FEB-1999 ZE. -- procedure moved to [.VMS.TOOLS] to be used by multiple
$!			manuals
$! 06-APR-1999 ZE. -- P1 = "*" means: translate all .HTML files
$!			ignore dates
$! 11-MAY-1999 ZE. -- P1 = "xxx" means: translate file xxx.HTML + ignore dates
$!-
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _DEV = F$PARSE(_PROCEDURE,,,"DEVICE")
$ _DIR = F$PARSE(_PROCEDURE,,,"DIRECTORY")
$ set default '_DEV''_DIR'		! = [.VMS.TOOLS]
$ _TOOLS = F$ENVIRONMENT("DEFAULT")
$ set default [-]			! = [.VMS]
$ _VMS = F$ENVIRONMENT("DEFAULT")
$ if ("''PYTHON'" .eqs. "")
$ then
$   @ '_VMS'SETUP
$ endif
$ set default '_DEFAULT'		! back to docu directory
$!
$ close /noLOG FIL_INP
$! ----------------------------------------------------------------------------
$ set DEFAULT []	! force directory delimiters
$ CVT_COUNT = 0
$! ----------------------------------------
$ if ((P1 .nes. "") .and. (P1 .nes. "*"))
$ then
$   H_DEV = F$PARSE(P1,"SYS$DISK:[].HTML;",,"DEVICE")
$   H_DIR = F$PARSE(P1,"SYS$DISK:[].HTML;",,"DIRECTORY")
$   H_NAM = F$PARSE(P1,"SYS$DISK:[].HTML;",,"NAME")
$   H_FILE = H_DEV + H_DIR + H_NAM + ".HTML"
$   R_FILE = H_DEV + H_DIR + H_NAM + ".RNO"
$   open /read FIL_INP 'H_FILE' /ERROR= ERR_OPENIN
$   read  FIL_INP T_RECORD
$   close FIL_INP
$   if (F$LOCATE("<RNO NOCONVERT>",T_RECORD) .ne. F$LENGTH(T_RECORD))
$   then
$     write SYS$ERROR "%CVT__HTML-W-CVTREJ, file conversion rejected due to <RNO NOCONVERT>"
$     write SYS$ERROR " \", H_FILE, "\"
$     goto E
$   endif
$   ! -----
$   write SYS$ERROR "%CVT__HTML-I-CVTFIL, converting file"
$   write SYS$ERROR " \", H_FILE, "\"
$   define /user_mode SYS$OUTPUT 'R_FILE'
$   python '_TOOLS'HTML2RNO.PY   'H_FILE'
$   CVT_COUNT = CVT_COUNT + 1
$   goto E
$   ! -----
$   ERR_OPENIN:
$   _STATUS = $STATUS
$   write SYS$ERROR "%CVT__HTML-E-OPENIN, error opening ", H_FILE
$   write SYS$ERROR "-", F$EXTRACT(1,9999,F$MESSAGE(_STATUS))
$   goto E
$ endif
$! ----------------------------------------
$ F = F$SEARCH("",1)	! clear context !! WARNING! this procedure uses
$ F = F$SEARCH("",2)	! clear context !!   TWO search streams
$!
$LOOP:
$ F = F$SEARCH("*.HTML;",1)
$ if (F .eqs. "") then $ goto E
$!
$ _NAME      = F$PARSE(F,,,"NAME")
$ _FILE_HTML = F
$ _FILE_RNO  = _NAME + ".RNO"
$!
$ open /read FIL_INP '_FILE_HTML'
$ read  FIL_INP T_RECORD
$ close FIL_INP
$ if (F$LOCATE("<RNO NOCONVERT>",T_RECORD) .ne. F$LENGTH(T_RECORD))
$ then
$   write SYS$ERROR "%CVT__HTML-W-CVTREJ, file conversion rejected due to <RNO NOCONVERT>"
$   write SYS$ERROR " \", F, "\"
$   goto LOOP
$ endif
$!
$ if (P1 .eqs. "*")
$ then
$   CDT_RNO  = "1858-11-17 00:00:00.00"	! always translate
$   CDT_HTML = "9999-12-31 23:59:59.99"
$ else
$   CDT_HTML = F$CVTIME (F$FILE_ATTRIBUTES(_FILE_HTML,"CDT"), "COMPARISON","DATETIME")
$   if (F$SEARCH(_FILE_RNO,2) .eqs. "")
$   then
$     CDT_RNO = "1858-11-17 00:00:00.00"	! never translated before
$   else
$     CDT_RNO = F$CVTIME (F$FILE_ATTRIBUTES(_FILE_RNO,"CDT"), "COMPARISON","DATETIME")
$   endif
$ endif
$!
$ if (CDT_HTML .gts. CDT_RNO)
$ then
$   write SYS$ERROR "%CVT__HTML-I-CVTFIL, converting file"
$   write SYS$ERROR " \", _FILE_HTML, "\"
$   define /user_mode SYS$OUTPUT '_FILE_RNO'
$   python '_TOOLS'HTML2RNO.PY '_FILE_HTML'
$   CVT_COUNT = CVT_COUNT + 1
$ else
$   write SYS$ERROR "%CVT__HTML-I-NOCVT, converting not necessary for file"
$   write SYS$ERROR " \", _FILE_HTML, "\"
$ endif
$!
$ goto LOOP
$! ----------------------------------------
$E:
$  write SYS$ERROR "%CVT__HTML-I-CVTCNT, converted ''CVT_COUNT' files"
$ set DEFAULT '_DEFAULT'
